3
Frodo Sam Bilbo
Sam Frodo Bilbo
5
A B C D E
B A D E C
1
a
a
2
a b
a b
4
c d a b
b c a d
8
a h g b c f e d
d h a b c f e g
16
h bb a c e bc bf d i j bd f b g ba be
e ba i f d c bb be bd a g bc h j b bf
32
cf b ca ci cj f bh bg a cg cd h ce db e da g ba i bb cc cb bc bj bd bi be d ch bf j c
c g cj be bh cf f j bb ca ba bf ci h cg bg bc b bi i cc e cd db d da bd ch bj a cb ce
64
db cj ce dj da bh dc bf a cb c ei bd ci fg eb fh dh gd i bc f eh ff bg dg ea bi ed ch cf cd gb fb de d ef eg h be cg fa bb e bj fc ee fj ba g j ej fe ga fd ca cc gc df di b ec dd fi
da bj fe ca ei de ch be cc d ee fb fa bf fj fd ej dj b ci a f j ce eb ba bh gc dg bg fg cb fh cf ea di cg bc dc ga e cj ed fc cd g i bi ec fi gb bd dh c db ef ff dd bb eg h df eh gd
128
cd eh gh bbg eg bcb bbf fh hj bd bae ch bbb jf fe ig bh i fc baf ba ef ci j fi he di db ie bb g hf fb jg b ji be gg fd ij ih ff dh bbj bcf bj hg bc ei bi gj ja bai bbh ge cj cc bch je ee ic if ea gc ce eb gb bac hb bbd da fa de cf hd gd dg bbe h ib ii jj f ed jd bbc ca bcc jc ej df cg jb baa d fj dc ha hi bca bf a ga cb fg dj gi jh bba hc hh id bbi bad bah bcg bce bcd e c dd bag ec ia gf bg baj bab
baj bcd bj gi fh bce bbb jb hi cf da ce bcf bad dc ga ch bac gg bi bf bbe dh jg gb j jf ge dd ea bbh fe ja ig e fa df baf gf ec ji ic jd ih ca hc bb gj ee cg de fi je bc bbc bbj bab ba fb bbf baa ha bcg bd g bbg he ff ie bbd ii bca fg hh be hf gh bag eb ej bg bai jc hb b di f d bcb ci hg bh cd bbi gd jh bah fd h ei ed if cj ef fj ib dj jj bcc hd gc cc c bch id dg i fc ij a eh ia db eg bba bae hj cb
256
cfa bhg bea ij bbc eh bfb bfe ceb ba cdb gc ji cag ia bde eg bdc bgj cdj gi bgi bba cch cac cee cei je bgd cej jb bcb bjg cfc jf fg bge dg ca cf bbd cde bch bci bcd bfa hb cci ii gj ff cah bdg baj bcj jg bad big bjc bd cd gd jj bdj bjj jh bef cbf jc db bdh ge baa bc bfi ccb i cbj fj bbe cba bhj bae id fc d bbi fi bfh ccd bgb bga bda bgg bee bdd ceh bii cff bfg da beh cbc cbg bbf bcc ee cbb bih hd cae bij bfc bha bej bcf bhe bgh bbj jd ccc hh bic cce bhd bje gg cfd fd cb bca dc bhh ef eb bah caf ccg bjh bff dj bfd cbe fh bji hg dh g bdb bi caa ec bgf df bbh baf he cdd bhb bif bib bia ei cdh bac bbg a de ib bai bhi ce ceg bjb cdc hf bdf ha bja bed bce bab cec beg bhf bjf fe di ga bdi cda hi bb bie hc cai bg ced ie ci bei bbb if be bf e ch j cdg gb bfj fb gh bhc cad bjd dd bcg cc cbi ea beb cbd caj gf bag ic ccj cdi cca hj cg ed cfe bec f ih b cj ccf bgc ej fa cbh cfb cab cea c ig h ja bh bj bid cef cdf
cei baf bef bje dj bid ec ee jj b bfa bgi cca bja cce bai fe bee ic bga bic cef cdi bff ced cah cg hd bdb ei bhh bih c ccb beb bhj bcf ja gg hh cec ji cfc cbd gd ih he bbg if jc gb ha fj id bif hc fh bcb di f cbi bda eg e bcg bj bde cdb bji bij bi d bfh bcj ib cda bb cea bhi cai dh j bfb bbi bjc cbf ia bbb cdd bba bfi bgh jb gf db cad bib cfe cfa cf ig bgg bab ii bhb cbj bjd fa bdi bch bae cae dg fb hj ga bhc bf ff dd bfe cbe cba je bfd ij bbe bea ej bdd bdh bg bbd ed fg cdh hi cfb bjf bjb bfj eh ceb jg bha ce bac ccd ca de cci bc hg i bhf beh jf bhg bag big fc bah bdc cab cbg ceg cdg cfd ccg caj bge jd cj be ch eb cag bgb cdc ccj bei bbc cbb cd cbc caa bjg baj bbj cdf fd bfg hb bia bci cb bjh ef ge g bgc bca cac hf bcc bgf caf df bd bdg bbh gi a cee gj bad bhe dc ceh jh bcd ccc bdj bhd bii baa gh ie cej cbh cde ba bie bdf da h bbf cc cff beg cch cdj bgd bfc ccf ci bh bed bej bgj bec gc bce fi bjj ea
512
ebf dg bah eh did djh egf bcc eag ei bhi bed bja ejc cc edd ehc bic ge dij bjc dgb bb ed bgb cdd ch dac bgg bgf cbi ceg chg ddc cfc cdh ga dcj cib fbb ca fag cjj hg faa bcj efc dgf hc eje egc eeh bhf fba dcf eih db ej dbc cah eie daj bgc eia bfh eaa ejg dah dji eca gh cff efa dcc faj cji dhe bbi cii big edf dii faf dce cid dei dbi ee bbf fc dfa ddg bdb cgd eba cgi bhh c eed efj def caj bgd deh ij bci cec efd eij ecf jb gc bae dgg bii bhb gi bga chh cci edb ehe cig fab eai cbf ehj dhg dfc cbb dha if efg cfg ejj bdj caa a dea dbb fai bfg bee hd bgh cda bef eah cja bib bei ccf cce fb bhj ccd dhi cij edg bhe cfe bj eda dda eif eei fj bdh fah ebg ega cj cfb je bdg dde bji eec ccb chf da dfj dai gd edj cih egd ib fad cae dbg eaj de djf di beh efe cgh cee cie bih bab fh cad bca chj ha cef bcg bej bjf id bif ja cga bfe ehg bjb cd cbc dhc hb i cdf bag bdi dbd eic ecg dja eab bde cde bfa jc eac dbh dba bad cdb bfi ji ddb ebd cha dd ejf ic cch dib eef jf bha bjh bff dej bjj egj ddi cbe f ded cba bac ecb ceh d bfb dh cdg dfe dgd dcb gf ebj hh dec ege bij daa djb cgg bhg cej gj bid dag ead ec dfd ef baj ech ie dcg die dcd egb eej dif dci dfg dga fae cgb ceb cge bf eae bfd ehb dgc bec eeb efh bje fg bbb dj bbe eja gb cfj j bdd cgc bie dhf djd cjh bbh ddh cf chi bbj dgj cfi djg eji baf cb ejh gg dhb g fac ehd eea eb dab deg bia egi bfj bcf bfc ci cjb bcd cjf ehh edc bhc cdi bcb dhj dgi ih bgi ecd cg dae cic bc cea cca be cai efi fi dia dfh jj jh ehi baa hi dbf cbh dc ccj bdf ebc cei cjd cbj ece dch efb ecj cfh bjd fd fa ce bce bge ced che bbc dbe eaf dhd bda djc dfb dih bi ccg eg ia b beg cdj bh ccc cac ba bea daf fe dfi cab bg ehf edi chd ddj bgj ddf bba e bd ea eib dee dje bbd ecc cif ebi ebh he ede eha dgh ejd caf egg cag df eci edh bch ebe bbg deb cdc cje cjg dca eee cfa h bai eii cjc bjg cgj eff bhd chb eeg dbj hf dge ebb dig dic jd eig chc cgf egh dff ejb cbd beb bdc dhh dad djj cfd ff hj ddd ig ii eid cbg cia jg
bai ef bci jc bjj big ja dca bgc eaf ddc ha cij dff ehe eid ebb eja bhb cia ddg eac ced bga efe cfa gb bha bf dih chj bdi be ehi cji bag de djf djb bja cbb ecc fg daj e ejh faj cce fae fai dfg ejb gj bjg hb bbi ehf cfg chc cgb bbc dgj eh fh ecb bfa dej cid cgh cdh bd bfh dbe cah cib fbb cea if cdi che dei fj cag bhc chg bdf cbi bef bhh dja dde cj cja bgd cb ceb dge eib ejc ehb gc djc eee eca edd efg dcf bfb bge cg jf bee bc die bcb efj djh bgb cjf d cbj dch bje caf egi dfd ej dif ddh ebe bea eij cfi bed dhc dbf cca bgf da ecg cde ebg cei deh ejd dbd dgc edj efb jg cjh bbf cdc eaj cdb eah cge fe dha bjb ea ca ddi dbg bdg dhd fag bi cbe edb ebc dhf ede gh ie dae bb dgd ejj cac je cfh dab bjf dec dga bia hg cgf djg ed bh cbc cee eie eje dig faf jh djd bgg eji ccc bgh ead cfd cbg eaa dea ddj dbj f bbh bbb bei ih ebd dcj eci bfe bic bjd ccg cjg j bbg gi cdf cf ch edc bfg bgi baj bch efa di bcf gd bhe ejg bad bab bhf bcg hj dbi ji dah df ehd cbh def baa bji ddd beg eej fc cad bdj bcd bhj bhg eb daa ge id bae bce cdg cgd bbd eff egf dgh faa fb cgj ccf bde dhh dje b c ecf cii ei eha cfc cif i he beh dfc dhb bda eg hd baf dij beb cdj dgf dac edf ecd ij bg cci dji ded ee egd dfh hc eda ebj eag fa ecj ic bfi cab edi caa did eea bbe cdd eec ehj dda cga bcj bbj dg efi dbb ebh cie eeg cbd bcc ddb eae ib bj a chi bac ceh eeh cic dci dhj deb dgi dhg ia dbc cch cig cfj dc dbh dhi bij cai bjh h eef eei egc ehc dcc bej ece ig bdb fah dii cd fac dba cha bdh eab ege ehh cff cej cje dh deg dia dj ii ccd dhe chd dcb fad cjc bie bfj cc eia dfb hh bif fab ga ehg daf hi dib egg chh bhd ddf cec dfj cae bdd cfb hf bfd bhi eii bba efd caj ci cda ejf eif dai bib bih cef cjd eig ce egh fba eic dfa dcd egj ega egb cgg efh eai edh dfi cjj gf dcg bec jj cgc dfe cbf dag cjb dic bca fi chf bgj jb dce ceg fd ba ebf eba bfc cgi ebi ech db bah cih dgb bii ccb ccj eih cfe eed djj bjc bid jd chb dgg dee ff efc g edg dd bff gg eeb ec bdc dad cba
1024
ehb fhh bai eha bbd da bda cc ifi hdi cij ddf bag hhc babh fda jbi hac ecc fd baab fbh cfi egh ead fad hbi ieh gcc bac jha cba ice dgg fg bie cac gc fba hbb dhb icg icb bj jib jce hih babc bab dcd ibc gjf iff jbh ech ifb jif jii jgi ic cec chf ebc fb bhj chh gjc dcg gbf ced edb geg cie gbd iab dhe iij eef cgb jeh gbb bca ggj jjg dej bfj fef deb ia ede cca ihj gjh hgi hbf deg ii jhg eaj ida eig dcj hde jhd ggf hja eea dci fig cfa iga babe eji bjc bje ded bgf ieb hcb hfg fae bcj bib hef hae bea hcj ec fhd cgh hgc fee hab dad dgh ecb eac hf def fga iih fhi dgb feg bhg ici caj fjb gbj hgj fgg jgf chb faa dj bba iid jag hif dg babd egg dfh ijc cbh bgc ccg edc ejg ef ibj hbh ijb fh f dfc eeh bdh bhb bdi gga eda bcc fja ibb jge eci cbe bh bih gb ehd djg ijh fjg dgc cjd dfj jg jh jgh fbg gjj fhf dgf bacb ihg gea jij gfj ffi ege cdb cdc bej jcf bjh iej jai hje ifd dei chg gae gcf gid dhf bbf cef egj hha ehe cjf ibe fdd hjc dif dge hge icf baaf edi ci dbf fca gef bjg hjj gdc de gbc bbi fbb iic cid jfc jaj fch jf eia jcj egd eba fe bef bgi hbc fhg ehc bhf bg jah ja fcc ffh hdb ccb jcg gig dc hdf iac jhc ba jeg hca eid ich eah cgg haa bjb gcd bja jee chj babb jcd hhg hea ecj bii bbe baa ehj ca hji gdh ieg ehi jcb cif bdb babi ijf iba ihd fih ghf dcb ccj ejj igh gah fgb fcb fcd caf bic djh hdj dfi cfd cbf bch cbg jfe bd fjj cdi jfb fge baca jid ebi cbd hjb gfb cfj fce dia ch dig bed dde ceg babj icj jbg fhe cae gdg hhj ggb gej bfb hec iaa gee fej jdf gh daf chc di hbe fed hic cji bia jgd jdg hed fhb baag baf hfe chi dec gha iae gci jbj bbb ica die cdd hbg bgj ehg hfi eff fag fah hch hai fai eja fa g eii cdf edf ebg ijg efc gj bif cig hfa igi dbc jje fei gch edj fhj bdd gba hag ee fjh eaf jda caa cjb jji gie jfg ibd eb gd a hgg iec cde ggh egb gfe cf efh cih jdi cjh baba cdj ief ed jjc ged gcj cgj ejb jgg bge dca ihe ecg dfg bbh dab ga fbi ggd edh cjg ifc jih ifg geb ffj bgd ffg jhi iig ceb jbe cfb hcc haj bcg bij jhf d ffc cfg ide gjb cbb ied gca dij jhb dce jaf gaa big bff fdh gdi jfh dcf hfb bfd ehf ihc ddj dha dgi faj gge cbj eaa ijd bgh ggi efj fdi feb ebb gff bfh gbg cai fid bhi db fcg hg fgd fif fie ecd cfe beg bfc igg dea iah ghj gfg hce fff ece fgi babg h ghi jad fde gih eai dch hij gij hjg eej idh ddd gbh haf ihi hah icc ce beb hei fdf cbc ej chd hig iea feh iha fdg heh ffd bce bfg ddi ih hcf cja ejd dbd dje hfd ghe cb hgd ifh cff dbe gab bbg ifa cbi eeb bjf ijj ij hhi dii jab bhe bb bei jeb ie igd ibi dib daj hh ff iii eei gfa ige cah bid gje jfa cjj jec e hee jga gfc gjg ebd iai jjj ccc bi ghh ebe fbj ifj gfd baad ghg ibf dhh bci if iag gaj ghd bee baah jae fij cha dji baai hbd bacd fac hgh ib dga fj cge dbg cib dja jbc ebj cd bad dgj eif ig cgd jjb fjd iia dfd ccf dae jhe bcd fcj hfc gce cje dcc gec fab fji jef igf idg cgf hjf djb bfe hfh dic bjd cej bde iei fcf egf bgg gdd cch bcf jdj cda cj dfb jc hda jaa hfj bae c fdj fia gdf gcg fbe ggc idf gac jd dff djj bc geh jbf idi ejf jfi jdc cad ffb cci dhd babf jig bha eeg hjh cce bfa gfh jic had hbj gic iif daa efb ha fgc gde gai bf edg he egc fgj cfh efd ggg ihb hb gbi jjd icd jja bhd dhj bacc hba cee eec eih jba hib eg jb gii jia iji hej jdd cfc ddh ffe eae gf baaa bdc eij hhf iie fje ddb cii ebh dbi bhc eag hc fic jch eje fha djf jjf je fii eee efg gdb bbj jed fci cic bjj hii heb hcg jci iaj bhh cei jdh dda edd fdc hdd eic ihh ejc dhg beh idd fbc ife gag hid ebf hff ceh ddc jff igc efe gdj dh jfj gib hdh fjf hhd gei fhc cag fgh b idb jhj baaj cdh bfi idc dbh df ija ega eie jfd jgj ji jca ccd efi dag ihf dee dd gji dba eca baae ghb hdg dgd gfi jei dbj fbd jea gaf fbf dfa bec ge jde egi hga fjc cab gi djc eed dhc dfe cjc hi ejh efa dai cdg deh fi fea bdf dac gjd dbb bah iib ehh hie hci cgi j gg hdc ei gad i jhh cea che ffa hjd jbd bji jie jac bdj iee iaf fc jej jcc igb djd gia fec dih fib cg ije eab eh jgc fgf did id iad dah igj jgb dhi bcb bdg hgf be ea hd fdb faf gda hia cga hgb jj gif eib heg idj hhe bbc hhh ibg gja hhb jdb bga ecf gbe hcd cgc baj bgb ibh hj jbb ddg gcb jjh cia ghc baac
fbb fad cch ifd dcg eef egd ija eif eec ehi ge ddf egc cfg ife bba bfc cee bed gha fhb deh hfa jab bga hcj iej ibb dia iib jch ej beg jge gag dfc caf hfh edb jjf icd gec hig ia jjc efi jgc eja had cji hih dfd fgg igf gad chf fdi iha beb iia cbf egj iji b djf df bjc fcc ijb jhj egg dfa cjc ghi jdh eie daf ica hei bfh fed gae bfg jcb ha gcf gah fe bee faf baf jca dce bacb icg jh hda cj hjg ihd hea cdc hed ffd ebi bdc ege iai idi hch hgg dgi bfi ggg dc efa jcg cha ibj jdb hai fj bdd jhi hg dgg ceg fgf bag fdd jdd di jgg hdc hid jig ebf ggd gih bca hcc bacc jg jbh fbc jhh ibc iea gfj gei cac dbf fdf dda cic fb hfb edc hic chb jfa hcf cae hgi ecj bhf ehh babd hgc hii cef hbb fig fhd bej jdi ed ccd hba eic geh ggf cdf ieh gga hf hjb hbj igi fba egb efc dec ffb feb ihg fci jdg cjj fhe chj idd fbi ghg if jj bai gcc gdj hcb cjb fia iii bcg hdg baai jda geg fja cbc gfg bhc ifj dic ghd cgi bie ehb cdg igh jja dhb cde jid cfe ijh cei gdg cai bfa gig jdj fcg bef icb bgc babh babi iac igj gca dij hc fi ebe bbh hjd cej jii ihc gda gaf ejh chd gfe ead ihj jeh gii hjh iid ejd chc fee dfe cgd gie gbd big cb jcd fcf efj iee hj hab gcb jeb jc cgc jgb gja baca ddj bad bjj cfd ibh eia dcb fgb hbf jb hhd gib ffj g bii hdh bha dcf jaf ggj dai hcg ici baah jbb jcf bgj cjd gbf dab gff cad gea gjj heb gbj cii jbc edi fgd ijd gdi babc caa baba bgg jec eah ffg ghh hbh hhh jed hjf ebj ccb fec f ca dif jjh ice ecf ebh ic cif eha hdj jgi hie hha i bid gij ibe jci hjj eff ega ffe gef iab bbc hhb gcg gif hff ief daa bhi bjf ea gbh eb hd bda dfg dbh iih ffc eii idj ec eac fag dad cdd jeg eei bji ceh be fea gee fbe cab fga ci ghj dbc baaj jji ejf bah eh fae jbj efg dha cgg dhi hci jgd cag eea cah ifc a hdi dd jej fei cea jbe ecg gb gid hif cff hgd jje bdj eij gfb ebb iaj fhc bcc jaj gbg ggh jfg haf fjh ifg fic eda gjd icc ig jha gf fbh chh caj hfe hhf bih bhd bac cd hfj fgi ga dcd ihb gfi jad dja fjd gc cbg eba fif ged igb db gfh dhd cig dgb ijj ede ehf ffi gbc ceb dgd jgf he fai jde dhh cfi jah hhc ihi fij eab cgh ggc ggi jhg ee bea bdh dcj cbe gej ifh dj dgc je hec id ghe idg bci edf gcj bif gac ce bgf ji dfj baac gbe dag dac ich gji fjj ff fda jcc dej hhg fah hae dei hfg gcd jbg hi bf bcb gdc iba dhc ehe jbf hdd jei cfb hb eaf cgj daj fbj ifa dfi jjg eeh ehd ibd ced baab c dii fhg ieb bij efb dbb djj dje gdf bgd iah efd fdc hfi jba fii haj dge cbj bhj bbb eib fcj dga dih fji ifi bhh hfc ejc gdb ied jae bgi bhg da bff jjj gge efh hje hib ebc bjh ddh bbg fje jcj cc iaa jhb fbf cgf eee hij eed baad hge jif hee jdf jfe edj ghf bcj iie cij ejj fce ef eid hah ehg hbg hja fid jfh bgh edh ibf jie feg babj fgc gjf hdb igd jef ece gjg ecc bgb fc bbj fh dgf fch baaf bi baae djg gjb gi fbg chi jgj cjf fdj d ffh ebg jd djh bfd gia ih cda hhi hbi ddg bfb bdb gj bdg fgj dch ecb dfb ccf cg fge gbb gjc feh gch jf jbd deg jhe baa eig dca hgh gje gfa hce gdh bje fjf cje hh fd ehj bacd dff bic hhj cf fca djc eaj gab dbg hac bbe cdb ihf bhe dbd eaa jff eai jfc hgf h gfd eg bei bbd bcf gba jdc gai jce fac bh bia gh iic cdj fha ibi ddb hbc idc ieg cdh cia babg cfj cid dib iaf jaa hde bc dee dhe idb babe bbf dig cjg jea dfh bjd ehc gci djd jee faj cjh iga cce iij dbe hcd ffa cba jib ei hgj hia igc ida fie fab dgh dae chg jfd dg cfh fhi dhj die cfc dci cib bde che ddc de iae jic bdi fjc iad babf jfj ba cdi ije fdb idf dhf hdf ch bjb dbj bbi icf bec gic jia igg ech hbd icj baj iif eca jga fg jfb ggb ccj ddi egi eej bch hgb jjd ebd dji dba cge bce hej bab gde bib jbi fbd fhh egf iag egh gaj bge hga babb fhf iei hca gbi cja gg fff jih geb bj jag jhc eeg hhe bhb cbh idh ddd cga bjg cbi ejb gd fdg ecd jac eeb gaa ghc hef eji gce gjh fa j cec dh ibg fcd iff hag bdf jfi iig bfj ie eag bcd bd dhg jhf jgh fib faa ejg ihh baag bb hfd bae ib fdh efe eih haa gdd jij fde cgb cca heg baaa ij cfa ifb jjb ccc cih fef fej jhd did fgh dcc hjc ihe dea ccg ige gfc eci beh edd hji cci hbe ded bfe dde bg ijf deb fih iec heh ii cbb eae djb dah ijc cbd dbi bja fcb def cie fjg e edg eje fjb ghb dgj ide ja fhj jai ijg
0
